# -*- python -*- vim:et:ts=4

import os
import sys
import socket
import string
from string import split
import whrandom
import cPickle
import time
import thread
import whrandom
import select

# My IRCClient class. This is sufficient for writing very simple bots.
class IRCClient:

    def __init__(self, server, port, nick, password, user, myhost, realname, periodic = None):
    	self.count = 0
        self.periodic = periodic
        print "Attempting to connect to server..."
        self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.socket.connect((server, port))
        print "Connected. Logged in..."
        self.fd = self.socket.makefile("r")
        if password:
            self.send("PASS :" + password)
        self.send("NICK " + nick)
        self.send("USER " + nick + " " + myhost + " " + server + " :" + realname)
        self.read()
        print "Logged in."

    def __del__(self):
        self.quit("No particular reason, just got bored (or crashed more likely)")

    def quit(self, reason):
        self.send("QUIT :" + reason)
        self.socket.close()

    def send(self, string):
    	self.count = self.count + len(string) + 1
        print "> " + string
        self.socket.send(string + "\n")

    def recv(self):
        while 1:
            res = select.select([self.fd],[],[],5.0)
            if len(res[0]): break
            if self.periodic: self.periodic()
    	s = self.fd.readline()
	    self.count = self.count + len(s)
        return s

    def join(self, channel):
        self.send("JOIN " + channel)
        self.lastchan = channel

    def op(self, channel, user):
        self.send("MODE " + channel + " +o " + user)
        
    def say(self, to, text):
        self.send("PRIVMSG " + to + " :" + text)

    def action(self, to, text):
        self.say(to, chr(1) + "ACTION " + text + chr(1))

    def chomp(self, text):
    	if text == "": return ""
        if text[0] == ":": text = text[1:]
        return string.strip(text)

    def read(self):
        command = "PING"
        while command == "PING":
            i = string.strip(self.recv())
            print "< " + i
	        if i == "":
	            print "Null received, sleeping then exiting"
		        time.sleep(20)
	   	        sys.exit(20)
	        if i[0] == ":": i = i[1:]
            sender = ""
            tail = ""
            try:
                (sender, command, tail) = split(i, " ", 2)
                sender = self.chomp(sender)
            except ValueError:
                try:
                    (command, tail) = split(i, " ", 1)
                except ValueError:
                    command = i
            if command == "PING":
                self.send("PONG " + tail)
        return (sender, command, tail)

    def listen(self):
        while 1:
            (sender, command, tail) = self.read()
            sendnick = self.getnick(sender)
            if command == "PRIVMSG":
                (receiver, text) = split(tail, " ", 1)
                text = self.chomp(text)
                return ("say", sendnick, receiver, text)
            if command == "KICK":
                return ("kick", sendnick, string.split(tail, " ")[0], string.split(tail, " ")[1])
            if command == "JOIN":
                channel = self.chomp(tail)
                return ("join", sendnick, channel, sender)
            if command == "PART":
                channel = self.chomp(tail)
                return ("leave", sendnick, channel)
                
    def getnick(self, s):
        return split(s, "!", 1)[0]


