#!/bin/python

import copy
from threading import *

class RequestQueue:
    def __init__(self):
        self.queue = []
        self.lock = Lock()

    def is_empty(self): return (len(self.queue) == 0)
    def clear(self): self.queue = []
    def add_end(self, song):
        if not song in self.queue: self.queue.append(song)
    def get_next(self): return self.queue.pop(0)
    def get_queue(self): return copy.copy(self.queue)

    def remove(self, song):
        try:
            self.queue.remove(song)
        except ValueError:
            pass

if __name__ == "__main__":
    q = RequestQueue()
    assert q.is_empty()
    q.add_end("a")
    q.add_end("b")
    assert not q.is_empty()
    assert q.get_next() == "a"
    q.add_end("c")
    q.add_start("d")
    assert q.get_next() == "d"
    assert q.get_next() == "b"
    assert q.get_next() == "c"
