#!/bin/python

import os, urllib

class SongClient:
    def __init__(self, url):
        self.url = url
        self.enabled = 1

    def get_enabled(self): return self.enabled
    def set_enabled(self, value): self.enabled = value

    def get_songs(self):
        if not self.enabled: return []
        try:
            file = os.popen("wget -q -O - \"" + self.url + "?mode=list\"")
        except:
            return []
        list = []
        while 1:
            try:
                filename = file.readline()
                if not filename: break
                title = file.readline()
                if not title: break
                artist = file.readline()
                if not artist: break
            except IOError:
                break
            list.append((filename.strip(), title.strip(), artist.strip()))
        file.close()
        return list

    def get_song_url(self, filename):
        if not self.enabled: return "invalid"
        return self.url + "/" + urllib.quote(filename, "")

if __name__ == "__main__":
    sc = SongClient("http://stue407.ukc.ac.uk:81/funk/songserver.cgi")
    list = sc.get_songs()
