#!/usr/local/bin/python

import cgi, sys, traceback, whrandom, os
from FunkClient import *

#print "Content-type: text/plain\r\n\r\nFUCK OFF!"
#sys.exit(0)

class BadArgsException(Exception): pass

class FunkMaster:
    def __init__(self):
        self.random = whrandom.whrandom()
    
    def show_head(self, title, refresh = None):
        songs = self.client.playing()
        if len(songs):
            song = songs[0]
            playing = song.get_title() + " - " + song.get_artist()
            id = song.get_id()
        else:
            playing = "None"
            id = 0
            
        print """<?xml version="1.0" encoding="UTF-8"?>
        <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "DTD/xhtml1-strict.dtd">
        <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
        <head>"""
        if refresh:
            print "<meta http-equiv=\"refresh\" content=\"" + refresh + "\">"
        print """<link rel="stylesheet" href="/~azz/funkmaster_style.css"
        type="text/css">
        <title>FunkMaster: """ + title + """</title></head>
        <body>
        <h1>FunkMaster</h1>
        <div class="playing">Currently playing: """ + playing

        if self.authorised:
            print """(<a href="funkmaster.cgi?mode=skip&id=""" + str(id) + """">skip this</a>)"""

        print """</div>
        <p><form class="search" method="get" action="funkmaster.cgi">
        <input type="hidden" name="mode" value="search">
        Search for <input type="text" name="key" size="20" value="">
        in <input type="radio" name="on" value="title" checked="1"> title
        <input type="radio" name="on" value="artist"> artist
        <input type="submit" value="Go">
        or <a href="funkmaster.cgi?mode=random">show some random songs</a>
        </form></p>

        <h2>""" + title + """</h2>"""

    def show_foot(self):
        print """</body></html>"""

    def main(self):
        print """Content-type: text/html\r\n\r\n""",

        self.client = FunkClient("onyx.config")
        
        self.form = cgi.FieldStorage()
        if self.form.has_key("mode"):
            mode = self.form["mode"].value
        else:
            mode = "main"

        self.authorised = 0
        authhosts = self.client.config["authhosts"].split(" ")
        if authhosts[0] == "*" or os.environ["REMOTE_ADDR"] in authhosts:
            self.authorised = 1

        try:
            method = getattr(self, "mode_" + mode)
        except AttributeError:
            self.show_head("Unknown mode")
            print """<p>Sorry, I don't know that mode.</p>"""
        else:
            try:
                method()
            except BadArgsException:
                self.show_head("Bad arguments")
                print """<p>Sorry, I don't understand what you mean.</p>"""

        if mode != "main":
            print """<p><a href="funkmaster.cgi?mode=main">Return to
            queue view</a></p>"""

        self.show_foot()
        self.client.quit()

    def get_arg(self, arg):
        if not self.form.has_key(arg): raise BadArgsException, arg
        return self.form[arg].value

    def get_arg_num(self, arg):
        try:
            return string.atoi(self.get_arg(arg))
        except ValueError:
            raise BadArgsException, arg

    def show_songs(self, songs, requestable = 1, removeable = 0):
        print """<p>"""
        if requestable:
            print """<form method="post" action="funkmaster.cgi">"""
            print """<input type="hidden" name="mode" value="multirequest">"""
        print """<table class="songlist">"""
        print """<tr class="tablehead"><td></td><td>Title</td><td>Artist</td><td></td></tr>"""
        for s in songs:
            print """<tr class="tablesong"><td>"""
            if requestable and len(songs) > 1:
                print """<input type="checkbox" name="id""" + str(s.get_id()) + """" value="1">"""
            print """</td><td>""" + s.get_title()
            print """</td><td>""" + s.get_artist() + """</td><td>"""
            if requestable:
                print """<a href="funkmaster.cgi?mode=request&id=""" + str(s.get_id()) + """">request</a>"""
            if removeable and self.authorised:
                print """<a href="funkmaster.cgi?mode=remove&id=""" + str(s.get_id()) + """">remove</a>"""
            print """</td></tr>"""
        print """</table>"""
        if requestable:
            if len(songs) > 1: print """<br /><input type="submit" name="multi" value="Request all checked songs">"""
            print """</form>"""
        print """</p>"""

    def mode_main(self):
        queue = self.client.queue()
        self.show_head("Requests in queue", "30")
        self.show_songs(queue, 0, 1)

    def mode_search(self):
        key = self.get_arg("key")
        on = self.get_arg("on")
        if not on in ["artist", "title"]: raise BadArgsException, "on"
        if on == "artist":
            songs = self.client.search_artist(key)
        else:
            songs = self.client.search_title(key)
            
        self.show_head("Search for \"" + key + "\" in " + on)
        print """<p>Found """ + str(len(songs)) + """ results.</p>"""
        self.show_songs(songs)

    def mode_request(self):
        id = self.get_arg_num("id")
        self.client.request(id)
        self.show_head("Request added")

    def mode_multirequest(self):
        self.show_head("Multiple requests added")
        ids = [x[2:] for x in self.form.keys() if x[:2] == "id"]
        for id in ids:
            try:
                nid = string.atoi(id)
                self.client.request(nid)
            except ValueError:
                pass

    def mode_remove(self):
        if not self.authorised: return
        id = self.get_arg_num("id")
        self.client.remove(id)
        self.show_head("Requested song removed from queue")

    def mode_skip(self):
        if not self.authorised: return
        id = self.get_arg_num("id")
        self.client.skip(id)
        self.show_head("Current song skipped")
        print """<p>Skipped current song.</p>"""

    def mode_random(self):
        n = self.client.count()
        songs = []
        for x in range(20):
            rn = self.random.randint(0, n-1)
            songs += self.client.list(rn, rn+1)
        self.show_head("Random songs")
        self.show_songs(songs)
        print """<p><a href="funkmaster.cgi?mode=random">More random songs</a></p>"""

if __name__ == "__main__":
    f = FunkMaster()
    try:
        f.main()
    except:
        print "\n\n<pre>"
        sys.stderr = sys.stdout
        traceback.print_exc()
    
