#!/usr/bin/perl
# The Funk songserver. Modify the functions below to match your system.
# Adam Sampson <funk@azz.us-lot.org>

sub get_title { # Extract the song title from a filename.
  ($_) = @_;
  if (/(.*\/)?([^\/]*) - ([^\/]*)\.mp3/i) { return $2; }
  s/(.*\/)?([^\/]*)\.mp3/$2/i;
  return $_;
}
sub get_artist { # Extract the artist from a filename.
  ($_) = @_;
  if (/(.*\/)?([^\/]*) - ([^\/]*)\.mp3/i) { return $3; }
  return "Unknown";
}
sub allow_file { # Say whether a given filename can be requested or not.
  ($_) = @_;
  if (/^\/home\/azz\/Sound\/mpeg3\/lists\/bytitle\//) { return 1; }
  return 0;
}

use CGI;
$cgi = new CGI;

$mode = ($cgi->param("mode") or "unknown");

if ($mode eq "list") {
  print "Content-type: text/plain\r\n\r\n";
  open FILE, "<playlist" or die "what playlist?";
  while ($filename = <FILE>) {
    chomp $filename;
    print $filename . "\n";
    print &get_title($filename) . "\n";
    print &get_artist($filename) . "\n";
  }
  close FILE;
} elsif ($ENV{"PATH_INFO"}) {
  print "Content-type: application/octet-stream\r\n\r\n";
  $file = $ENV{"PATH_INFO"} or die "specify file";
  $file =~ s/\/\.\.//g;
  die $file . " is not allowed" unless (&allow_file($file));
  open FILE, "<$file" or die $file . " is not openable";
  print $buf while (read FILE, $buf, 4096);
  close FILE;
} else {
  print "Content-type: text/html\r\n\r\n";
  print "<html><body>This script is not meant for interactive use.";
  print "Sod off.</body></html>";
}
